/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define ARC 10
#define X 20
#define Y 20
static GC gc;
static Dimension width, height;
static unsigned int rw = 0, rh = 0;
static int px, py;

/* ɥꥢΥĴ٤ƿ޷ΰ֤ȥƷ׻ */
static void ResetSizeAndPos(w)
    Widget w;
{
    unsigned int old_w, old_h;
    old_w = rw;
    old_h = rh;

    /* ɥꥢΥĴ٤ */
    XtVaGetValues(w, XmNwidth, &width, XmNheight, &height, NULL);

    /* ĹΥƷ׻ */
    rw = width - X * 2;
    rh = height - Y * 2;

    /* ߤΰ֤Ʒ׻ */
    if (old_w == 0) px = width / 2;
    else            px = (double)(px - X) * (double)rw / (double)old_w + X;
    if (old_h == 0) py = height / 2;
    else            py = (double)(py - Y) * (double)rh / (double)old_h + Y;
}

/* ɥꥢ˿޷ */
static void Redraw(w)
    Widget w;
{
    XDrawRectangle(XtDisplay(w), XtWindow(w), gc, X, Y, rw, rh);
    XFillArc(XtDisplay(w), XtWindow(w), gc, px - ARC/2, py - ARC/2, ARC, ARC,
             0, 360*64);
}

/* (5) ٥Ƚؿ (Хå) */

/* ɥꥢΥѤȿ޷ΥƷ׻ */
static void ResizeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    ResetSizeAndPos(w);
    XClearWindow(XtDisplay(w), XtWindow(w));
    Redraw(w);
}

/* ɥꥢϪФȤ˿޷ */
static void ExposeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Redraw(w);
}

/* ɥꥢǥܥ󤬲줿˿޷ */
static void InputCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    if (cb->event->type == ButtonPress) {
        px = cb->event->xbutton.x;
        py = cb->event->xbutton.y;
        XClearWindow(XtDisplay(w), XtWindow(w));
        Redraw(w);
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget   toplevel, panel, canvas;
    Arg      al[20];
    int      ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    /* (1) Xġ륭åȤ (ǥץ쥤򥪡ץ) */
    toplevel = XtAppInitialize(&app_context, "XMdraw", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    /* (2) åȤƥޥ͡ */
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);
    /* (3) ٥Ƚؿ (Хå) Ͽ */
    XtAddCallback(canvas, XmNresizeCallback, ResizeCB, NULL);
    XtAddCallback(canvas, XmNexposeCallback, ExposeCB, NULL);
    XtAddCallback(canvas, XmNinputCallback,  InputCB,  NULL);

    /* ΰ֤ȥ׻ */
    ResetSizeAndPos(canvas);

    XtRealizeWidget(toplevel);
    /* (2') ǥɥ */

    /* (4) եåƥȤ° */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XSetLineAttributes(XtDisplay(canvas), gc, 2, LineSolid, CapButt, JoinMiter);

    XtAppMainLoop(app_context);
}
